function [SE_5perc_max, Xuav_opt, Yuav_opt] = OptimizeUAVlocation(Xm, Ym, Zm, Xue, Yue, Pm, Puav, NoUAVs, HeightUAV, LenSimArea, PLE)

X = -0.7*LenSimArea/2:0.1:0.7*LenSimArea/2;
Y = -0.7*LenSimArea/2:0.1:0.7*LenSimArea/2;
[Xuav,Yuav] = ndgrid(X,Y); Xuav=Xuav(:); Yuav=Yuav(:);

Xuav_opt = [];
Yuav_opt = [];
SE_5perc_max = zeros(NoUAVs,1);
for m = 1:NoUAVs
    SE_5perc = zeros(size(Xuav));
    for n = 1:length(Xuav)
        Xuavs = [Xuav_opt; Xuav(n)]; Yuavs = [Yuav_opt; Yuav(n)]; Zuavs = HeightUAV*ones(size(Xuavs));
        SE_5perc(n) = Calc5thPercentileSE(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Xuavs, Yuavs, Zuavs, Puav);
    end
    
    [SE_5perc_max(m), idx_SE_5perc_max] = max(SE_5perc);
    Xuav_opt = [Xuav_opt; Xuav(idx_SE_5perc_max)];
    Yuav_opt = [Yuav_opt; Yuav(idx_SE_5perc_max)];
end

end