function [SE_5perc_max, Xuav_opt, Yuav_opt] = GA_OptimizeUAVlocation(Xm, Ym, Zm, Xue, Yue, Pm, Puav, NoUAVs, HeightUAV, LenSimArea, PLE, REB)

    mutation_rate = 0.1;
    crossover_rate = 1;
    
    Xuav_opt = [];
    Yuav_opt = [];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    index = NoUAVs*2;

for UAV = 1:length(index) % for NoUAVs are 5, 10, 15
    GenSize = index(UAV);
    PopSize = 60;
    iter = 100+index(UAV);
    Pop = (rand(PopSize,GenSize)-0.5)*0.7*LenSimArea;
 
%     X = -0.7*LenSimArea/2:0.5:0.7*LenSimArea/2;
%     Pop = X(ceil(rand(PopSize,GenSize)*length(X)));

    % Objective Function
    for n = 1:PopSize
        Xuav = [Pop(n,1:GenSize/2)]';
        Yuav = [Pop(n,GenSize/2+1:end)]';
        Zuav = HeightUAV*ones(size(Xuav));
        SE_5perc(n) = Calc5thPercentileSE(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Xuav, Yuav, Zuav, Puav, REB);
    end

    SE_5perc_max_temp = max(SE_5perc);

    % Fitness Values
    [A B] = sort(SE_5perc,'descend');
    [C D] = sort(A,'descend');
    fitness(B(:)) = (PopSize+1-D)./PopSize;
    fitness = fitness';

    for i=1:iter
        [fitness_max, idx_fitness_max] = max(fitness);
        Elitist = Pop(idx_fitness_max,:);

        % Selection Operator
        [Selection] = F_Selection(fitness,crossover_rate);

        % Matching
        Parent1(1:PopSize/2,:) = Pop(Selection(1:PopSize/2,1),:);
        Parent2(1:PopSize/2,:) = Pop(Selection(PopSize/2+1:2*PopSize/2,1),:);

        % One Point Crossver Operator
        point = ceil(rand(PopSize/2,1)*(GenSize-1));
        Child1 = zeros(PopSize/2,GenSize);
        Child2 = zeros(PopSize/2,GenSize);
        Child1(:,1:point)=Parent1(:,1:point);Child1(:,point+1:GenSize)=Parent2(:,point+1:GenSize);
        Child2(:,1:point)=Parent2(:,1:point);Child2(:,point+1:GenSize)=Parent1(:,point+1:GenSize);

        Pop=cat(1,Child1,Child2);

        % Mutation Operator for Pop 1
        mo=(rand(PopSize,GenSize)-0.5)*2;
        mo_a=zeros(PopSize,GenSize);
        for i=1:PopSize
            for j=1:GenSize
                if abs(mo(i,j))<mutation_rate
                    mo_a(i,j)=1;
                end,
            end;
        end;
        Pop=Pop+(mo.*mo_a);
        
       % Mutation Operator for Pop 2
%         mo = rand(PopSize,GenSize);
%         for i=1:PopSize
%             for j=1:GenSize
%                 if mo(i,j)<mutation_rate
%                     Pop(i,j) = X(ceil(rand(1)*length(X)));
%                 end
%             end
%         end
    
        % Objective Function
        for n = 1:PopSize
            Xuav = [Pop(n,1:GenSize/2)]';
            Yuav = [Pop(n,GenSize/2+1:end)]';
            SE_5perc(n) = Calc5thPercentileSE(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Xuav, Yuav, Zuav, Puav, REB);
        end

        % Fitness Values
        [A B] = sort(SE_5perc,'descend');
        [C D] = sort(A,'descend');
        fitness(B(:)) = (PopSize+1-D)./PopSize;

        % Elitisim
        [A B]=min(fitness);
        Pop(B,:)=Elitist(1,:);
        SE_5perc(B) = SE_5perc_max_temp;

        % Fitness Values
        [A B] = sort(SE_5perc,'descend');
        [C D] = sort(A,'descend');
        fitness(B(:)) = (PopSize+1-D)./PopSize;
        SE_5perc_max_temp = max(SE_5perc);
    end    

    [fitness_max, idx_fitness_max] = max(fitness);
    SE_5perc_max(UAV) = SE_5perc(idx_fitness_max);
    Pop_Last = Pop(idx_fitness_max,:)';
    Xuav_opt = [Xuav_opt; Pop_Last(1:GenSize/2,:)];
    Yuav_opt = [Yuav_opt; Pop_Last(GenSize/2+1:GenSize,:)];
    clear fitness Pop Parent1 Parent2 Child1 Child2
end
end