function [Xuav, Yuav] = FindUAVlocation_HexGrid(NoUAVs, LenSimArea)

Xdist = LenSimArea;
Ydist = LenSimArea;
area_cell = Xdist*Ydist/NoUAVs;
d = sqrt(2*area_cell/sqrt(3)); % Inter-site distance (flat to flat side of hexagon)
h = d*sqrt(3)/2;
row = (d/2:d:Xdist);
col = (h/2:h:Ydist);
[Xuav, Yuav] = meshgrid(row, col);

temp = d/2*ones(size(Xuav));
temp(1:2:end,:) = 0;
Xuav = Xuav + temp;
Xuav = Xuav(:);
Yuav = Yuav(:);

Xuav = Xuav - min(Xuav);
Yuav = Yuav - min(Yuav);
Xuav = Xuav - max(Xuav)/2;
Yuav = Yuav - max(Yuav)/2;

figure(10);
plot(Xuav,Yuav,'xm','LineWidth',3,'MarkerSize',12);
set(gca,'Fontsize',12);
xlabel('X-axis distance (km)','Fontsize',12);
ylabel('Y-axis distance (km)','Fontsize',12);
title([num2str(NoUAVs) ' UAVs']);
legend('UAVs');
xlim([-Xdist/2,Xdist/2]);
ylim([-Ydist/2,Ydist/2]);

end